package com.hexace.editor
{
	import com.hexace.editor.controller.AddModuleCommand;
	import com.hexace.editor.controller.DeleteModuleCommand;
	import com.hexace.editor.controller.LoadCustomer;
	import com.hexace.editor.controller.LoadCustomerDetailsCommand;
	import com.hexace.editor.controller.LoadModuleDetailsCommand;
	import com.hexace.editor.controller.LoadModulesListCommand;
	import com.hexace.editor.controller.LoadXMLCommand;
	import com.hexace.editor.controller.UpdateModuleCommand;
	import com.hexace.editor.events.CustomerEvent;
	import com.hexace.editor.events.ModuleEvent;
	import com.hexace.editor.events.ServiceRequestEvent;
	import com.hexace.editor.model.ComponentModel;
	import com.hexace.editor.model.CustomerModel;
	import com.hexace.editor.model.FunctionalityModel;
	import com.hexace.editor.model.ModuleModel;
	import com.hexace.editor.model.PageModel;
	import com.hexace.editor.services.ConfigParser;
	import com.hexace.editor.services.ConfigService;
	import com.hexace.editor.services.IConfigParser;
	import com.hexace.editor.view.CustomerPanelView;
	import com.hexace.editor.view.CustomerPanelViewMediator;
	import com.hexace.editor.view.FunctionalitiesMediator;
	import com.hexace.editor.view.FunctionalitiesView;
	import com.hexace.editor.view.ModuleFormMediator;
	import com.hexace.editor.view.ModuleFormView;
	import com.hexace.editor.view.ModulesListMediator;
	import com.hexace.editor.view.ModulesListView;
	
	import flash.display.DisplayObjectContainer;
	
	import mx.events.FlexEvent;
	import mx.rpc.http.HTTPService;
	
	import org.robotlegs.mvcs.Context;

	public class HexaceEditorContext extends Context
	{
		public function HexaceEditorContext(contextView:DisplayObjectContainer=null, autoStartup:Boolean=true)
		{
			super(contextView, autoStartup);
		}
		override public function startup():void
		{	
			///////////// added by Ondina listen for FlexEvent.APPLICATION_COMPLETE 
			this.contextView.addEventListener(FlexEvent.APPLICATION_COMPLETE, onApplicationComplete);
			
			injector.mapClass(HTTPService, HTTPService);//
			/* MODELS */
			injector.mapSingleton(CustomerModel);
			injector.mapSingleton(ModuleModel);
			injector.mapSingleton(FunctionalityModel);
			injector.mapSingleton(PageModel);
			injector.mapSingleton(ComponentModel);
			
			/* SERVICES */
			/*injector.mapSingletonOf(ConfigService, ConfigService);
			injector.mapSingletonOf(ConfigParser, ConfigParser);*/
			///////////// modified by Ondina
			injector.mapSingleton(ConfigService);//using an interface would be better, like with the ConfigParser
			injector.mapSingletonOf(IConfigParser, ConfigParser);
			/* MEDIATORS */
			mediatorMap.mapView(CustomerPanelView, CustomerPanelViewMediator);
			mediatorMap.mapView(ModulesListView, ModulesListMediator);
			mediatorMap.mapView(ModuleFormView, ModuleFormMediator);
			///////////// added by Ondina
			mediatorMap.mapView(FunctionalitiesView, FunctionalitiesMediator);
			/* COMMANDS */
			//commandMap.mapEvent(CustomerEvent.LOAD_CUSTOMER_XML, LoadCustomer);//maybe it should be a separate event like below:
			
			///////////// added by Ondina
			commandMap.mapEvent(ServiceRequestEvent.LOAD_XML, LoadXMLCommand);
			commandMap.mapEvent(ServiceRequestEvent.XML_LOADED, LoadCustomerDetailsCommand);
			
			commandMap.mapEvent(ModuleEvent.LOAD_MODULES, LoadModulesListCommand);
			commandMap.mapEvent(ModuleEvent.SELECT_MODULE, LoadModuleDetailsCommand);
			commandMap.mapEvent(ModuleEvent.ADD_MODULE, AddModuleCommand);
			commandMap.mapEvent(ModuleEvent.DELETE_MODULE, DeleteModuleCommand);
			commandMap.mapEvent(ModuleEvent.UPDATE_MODULE, UpdateModuleCommand);
			
		}
		
		///////////// added by Ondina
		private function onApplicationComplete(event:FlexEvent):void
		{
			trace("HexaceEditorContext.onApplicationComplete(event)");
			//triggering LoadCustomer Command on FlexEvent.APPLICATION_COMPLETE
			var serviceRequestEvent:ServiceRequestEvent = new ServiceRequestEvent(ServiceRequestEvent.LOAD_XML);
			//var path:String="http://localhost/AmnesiacEditor/editor/";
			//serviceRequestEvent.path =path+ "config_3_0.xml";//better from a vo 
			serviceRequestEvent.path="config_2_0.xml";
			dispatchEvent(serviceRequestEvent);
		}
	}
}