package com.hexace.editor.model
{
    import com.hexace.editor.events.FunctionalityEvent;
    import com.hexace.editor.model.vo.functionality.Functionality;
    import mx.collections.ArrayCollection;
    import org.robotlegs.mvcs.Actor;

    public class FunctionalityModel extends Actor
    {

        public function FunctionalityModel()
        {
        }

        public var _functionalities:ArrayCollection=new ArrayCollection([]);

        private var _autoIncrementFunctionalityID:uint=1;
        private var functionalitiesList:ArrayCollection;

        public function get autoIncrementFunctionalityID():uint
        {
            return ++_autoIncrementFunctionalityID;
        }

        public function mapFunctionality(functionality:Functionality):void
        {
            trace("[Model]---FunctionalityModel.mapFunctionality(functionality) " + functionality.id + " moduleId " + functionality.moduleId);

            const eventType:String=containsFunctionalityWithID(functionality.id) ? FunctionalityEvent.FUNCTIONALITY_UPDATED : FunctionalityEvent.FUNCTIONALITY_ADDED;

            if (!functionality.id)
            {
                functionality=functionality.clone(autoIncrementFunctionalityID);
            }
            else
            {
                if (functionality.id > _autoIncrementFunctionalityID)
                {
                    _autoIncrementFunctionalityID=functionality.id;
                }
            }

            _functionalities.addItem(functionality);
            dispatch(new FunctionalityEvent(eventType, functionality.clone()));
        }

        public function getFunctionality(id:uint):Functionality
        {
            trace("[Model]---FunctionalityModel.getFunctionality(id) " + id);

            for (var i:uint; i < _functionalities.length; i++)
            {
                var functionality:Functionality=_functionalities[i] as Functionality;
                if (functionality.id == id)
                    return functionality;
            }
            return null;
        }

        /*public function getModuleFunctionalities(moduleId:uint):Vector.<Functionality>
		{
		var moduleFunctionalities:Vector.<Functionality> = new Vector.<Functionality>;
		
		for(var i:uint; i<_functionalities.length; i++)
		{
		var functionality:Functionality = _functionalities[i] as Functionality;
		if(functionality.moduleId == moduleId)
		moduleFunctionalities.push(functionality);
		}
		
		return moduleFunctionalities;
		}*/
		
		///////////// added by Ondina
		public function getModuleFunctionalities(moduleId:int):void
		{
			trace("[Model]---FunctionalityModel.getModuleFunctionalities(moduleId) " + moduleId);
			functionalitiesList=new ArrayCollection();			
			for each (var functionality:Functionality in _functionalities)
			{
				if (functionality.moduleId == moduleId)
					functionalitiesList.addItem(functionality);
			}			
			dispatch(new FunctionalityEvent(FunctionalityEvent.FUNCTIONALITIES_LIST, null, functionalitiesList)); 
		}
		
		///////////// added by Ondina
        public function getFunctionalitiesByModuleId(id:int):Array
        {
            var functionalitiesArray:Array=[];
            for each (var functionality:Functionality in _functionalities)
            {
                if (functionality.moduleId == id)
                    functionalitiesArray.push(functionality);
            }
            return functionalitiesArray;
        }

		///////////// added by Ondina
        public function deleteFunctionality(id:int):void
        {
            trace("FunctionalityModel.deleteFunctionality(id)");
            var toDelete:Array=getFunctionalitiesByModuleId(id);
            var toDeleteLength:int=toDelete.length;
            var removeIndex:int;
            for (var i:int=0; i < toDeleteLength; i++)
            {
                removeIndex=_functionalities.getItemIndex(toDelete[i]);
                trace("todelete index " + toDelete[i] + " removeindex " + removeIndex);
                _functionalities.removeItemAt(removeIndex);
            }
            _functionalities.refresh();
            dispatch(new FunctionalityEvent(FunctionalityEvent.FUNCTIONALITY_DELETED));
        }

        // TODO: rozszerzyc ArrayCollection o pobieranie na podstawie ID (containsByID)
        private function containsFunctionalityWithID(id:uint):Boolean
        {
            trace("[Model]---FunctionalityModel.containsFunctionalityWithID(id) " + id);

            for each (var functionality:Functionality in _functionalities)
            {
                if (functionality.id == id)
                {
                    return true;
                }
            }
            return false;
        }
    }
}
