package com.hexace.editor.model
{
    import com.hexace.editor.events.ModuleEvent;
    import com.hexace.editor.model.vo.module.Module;
    import mx.collections.ArrayCollection;
    import org.robotlegs.mvcs.Actor;

    public class ModuleModel extends Actor
    {

        private var _autoIncrementModuleID:uint=1;
        private var _modules:ArrayCollection=new ArrayCollection([]);

        public function get autoIncrementModuleID():uint
        {
            return ++_autoIncrementModuleID;
        }

        public function mapModule(module:Module):void
        {
            const eventType:String=containsModuleWithID(module.id) ? ModuleEvent.MODULE_UPDATED : ModuleEvent.MODULE_ADDED;
            trace("[Model]---ModuleModel.mapModule(module) " + module.id + " eventType " + eventType);
            if (!module.id)
            {
                module=module.clone(autoIncrementModuleID);
            }
            else
            {
                if (module.id > _autoIncrementModuleID)
                {
                    _autoIncrementModuleID=module.id;
                }
            }

            _modules.addItem(module);
            //////////// not good because everytime a module gets added the mediator reacts:
            //dispatch(new ModuleEvent(eventType, module.clone()));	
        }

        public function getModule(id:uint):Module
        {
            for (var i:uint; i < _modules.length; i++)
            {
                trace("[Model]---ModuleModel.getModule(id) " + id);
                var module:Module=_modules[i] as Module;
                if (module.id == id)
                    return module;
            }
            return null;
        }

        public function get modules():ArrayCollection
        {
            return _modules;
        }

        ///////////// added by Ondina
        public function getModulesList():void
        {
            dispatch(new ModuleEvent(ModuleEvent.MODULE_ADDED, null, _modules));
        }

        ///////////// added by Ondina
        public function addModule(module:Module):void
        {
            trace("ModuleModel.addModule(id)");
            if (module.id <= _autoIncrementModuleID)
                module.id=_autoIncrementModuleID + 1;
            _modules.addItem(module);
            dispatch(new ModuleEvent(ModuleEvent.MODULE_ADDED, null, _modules));
        }

        ///////////// added by Ondina
        public function deleteModule(module:Module):void
        {
            trace("ModuleModel.deleteModule(id)");
            for each (var mod:Module in _modules)
            {
                trace("mod id " + mod.id + " modue.id " + module.id);
                if (mod.id == module.id)
                {
                    _modules.removeItemAt(_modules.getItemIndex(mod));
                    dispatch(new ModuleEvent(ModuleEvent.MODULE_DELETED, null, _modules));
                }
            }
        }

        ///////////// added by Ondina
        public function updateModule(module:Module):void
        {
            trace("ModuleModel.deleteModule(id)");
            for each (var mod:Module in _modules)
            {
                trace("mod id " + mod.id + " modue.id " + module.id);
                if (mod.id == module.id)
                {
                    mod.customerId=module.customerId;
                    mod.id=module.id;
                    mod.name=module.name;
                    mod.type=module.type;
                    dispatch(new ModuleEvent(ModuleEvent.MODULE_UPDATED, null, _modules));
                }
            }
        }

        ///////////// added by Ondina
        public function selectModule(module:Module):void
        {
            dispatch(new ModuleEvent(ModuleEvent.MODULE_SELECTED, module));
        }

        // TODO: rozszerzyc ArrayCollection o pobieranie na podstawie ID (containsByID)
        private function containsModuleWithID(id:uint):Boolean
        {
            trace("[Model]---ModuleModel.containsModuleWithID(id) " + id);

            for each (var module:Module in _modules)
            {
                if (module.id == id)
                {
                    return true;
                }
            }
            return false;
        }
    }
}
