package com.hexace.editor.services
{
    import com.hexace.editor.model.CustomerModel;
    import com.hexace.editor.model.FunctionalityModel;
    import com.hexace.editor.model.ModuleModel;
    import com.hexace.editor.model.vo.functionality.Functionality;
    import com.hexace.editor.model.vo.module.Module;
    import flash.xml.XMLNode;
    import mx.controls.Alert;
    import mx.managers.CursorManager;
    import mx.rpc.IResponder;
    import mx.rpc.events.ResultEvent;
    import mx.rpc.http.HTTPService;
    import org.robotlegs.mvcs.Actor;
//edited class name
    public class ConfigServices extends Actor implements IResponder
    {
        /*[Inject]
        public var configParser:ConfigParser;*/
        [Inject]
        public var configParser:IConfigParser; //using the interface instead of ConfigParser

        [Inject]
        public var customerModel:CustomerModel;

        [Inject]
        public var functionalityModel:FunctionalityModel;

        [Inject]
        public var httpService:HTTPService;

        [Inject]
        public var moduleModel:ModuleModel;

        private var _result:XML;

        public function load(path:String):void
        {
            trace("ConfigService.load(path) " + path);

            CursorManager.setBusyCursor();

            httpService.url=path;
            httpService.xmlDecode=decodeXML;

            httpService.send().addResponder(this);
        }

        public function result(data:Object):void
        {
            trace("ConfigService.result(data)");

            CursorManager.removeBusyCursor();
			//parsing and mappings to be refactored
            configParser.data=ResultEvent(data).result as XML;
//customermodel
            customerModel.customer=configParser.parseCustomer();
//moduleModel
            var modules:Vector.<Module>=configParser.parseModules(customerModel.customer.id);

            for (var mi:uint=0; mi < modules.length; mi++)
            {
                var module:Module=modules[mi] as Module;
                moduleModel.mapModule(module);

                var functionalities:Vector.<Functionality>=configParser.parseFunctionalitiesForModule(module.id);
//functionalityModel
                for (var fi:uint=0; fi < functionalities.length; fi++)
                {
                    var functionality:Functionality=functionalities[fi] as Functionality;
                    functionalityModel.mapFunctionality(functionality);
                }
            }
			trace("###################-LOADING AND PARSING COMPLETE");
        }

        public function fault(info:Object):void
        {
            CursorManager.removeBusyCursor();

            Alert.show("Config load error");
        }

        public function getConfig():XML
        {
            return _result;
        }

        public function getModuleFunctionalities(module:Module):XMLList
        {
            trace("ConfigService.getModuleFunctionalities(module)");

            return _result.customer.modules.module.(@name == module.name);
        }

        private function decodeXML(dataNode:XMLNode):Object
        {
            return XML(dataNode);
        }
    }
}
