package com.hexace.editor.view
{
    import com.hexace.editor.events.FunctionalityEvent;
    import com.hexace.editor.model.FunctionalityModel;
    
    import org.robotlegs.mvcs.Mediator;

    public class FunctionalitiesMediator extends Mediator
    {
        [Inject]
        public var functionalitiesListModel:FunctionalityModel;

        [Inject]
        public var view:FunctionalitiesView;

        override public function onRegister():void
        {
            trace("[Mediator]---FunctionalitiesMediator.onRegister() ");
            addViewListener(FunctionalityEvent.FUNCTIONALITY_SELECTED, dispatch);
            addContextListener(FunctionalityEvent.FUNCTIONALITIES_LIST, onFunctionalitiesDetailsLoaded);
            addContextListener(FunctionalityEvent.FUNCTIONALITY_DELETED, onFunctionalitiesDeleted);
        }

        private function onFunctionalitiesDetailsLoaded(event:FunctionalityEvent):void
        {
            trace("FunctionalitiesMediator.onModulesdetailsLoaded(event) " + event.functionalitiesList);
            view.functionalities=event.functionalitiesList;
        }

        private function onFunctionalitiesDeleted(event:FunctionalityEvent):void
        {
            view.functionalities=null;
        }
    }
}
